#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_NormalOutFishCFG1.h"
std::auto_ptr<Fish_NormalOutFishCFG1> Fish_NormalOutFishCFG1::msSingleton(nullptr);

int Fish_NormalOutFishCFG1::GetCount()
{
	return (int)mMapData.size();
}

const Fish_NormalOutFishCFG1Data* Fish_NormalOutFishCFG1::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_NormalOutFishCFG1Data>& Fish_NormalOutFishCFG1::GetMapData()
{
	return mMapData;
}

void Fish_NormalOutFishCFG1::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_NormalOutFishCFG1.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_NormalOutFishCFG1Data data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mType = element->IntAttribute("Type");
		data.mParamID = element->IntAttribute("ParamID");
		data.mOutWeight = element->IntAttribute("OutWeight");
		data.mOutMaxCount = element->IntAttribute("OutMaxCount");
		data.mRouteGroup = element->IntAttribute("RouteGroup");
		{
			const char* FishTime = element->Attribute("FishTime");
			std::vector<std::string> vecFishTime;
			boost::split(vecFishTime, FishTime, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFishTime.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFishTime[i].c_str(), &temp))
				{
					data.mFishTime.push_back(temp);
				}
			}
		}
		data.mGroupID = element->IntAttribute("GroupID");
		data.mFishNotice = element->IntAttribute("FishNotice");
		data.mGroupMaxFish = element->IntAttribute("GroupMaxFish");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_NormalOutFishCFG1 Loaded. Load Data:%u", mMapData.size());
}

void Fish_NormalOutFishCFG1::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_NormalOutFishCFG1");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_NormalOutFishCFG1");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_NormalOutFishCFG1Data data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "ParamID", data.mParamID);
		LuaCfgHelper::readInt(L, "OutWeight", data.mOutWeight);
		LuaCfgHelper::readInt(L, "OutMaxCount", data.mOutMaxCount);
		LuaCfgHelper::readInt(L, "RouteGroup", data.mRouteGroup);
		LuaCfgHelper::readVectorInt(L, "FishTime", data.mFishTime);
		LuaCfgHelper::readInt(L, "GroupID", data.mGroupID);
		LuaCfgHelper::readInt(L, "FishNotice", data.mFishNotice);
		LuaCfgHelper::readInt(L, "GroupMaxFish", data.mGroupMaxFish);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_NormalOutFishCFG1 Loaded. Load Data:%u", mMapData.size());
}

void Fish_NormalOutFishCFG1::Reload()
{
	mMapData.clear();
	Load();
}

Fish_NormalOutFishCFG1* Fish_NormalOutFishCFG1::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_NormalOutFishCFG1());
	}
	return msSingleton.get();
}

void Fish_NormalOutFishCFG1::Release()
{
	msSingleton.reset(nullptr);
}
